@import "../../../../core/variables";

.container {
  display: inline-flex;
  align-items: center;
  user-select: none;

  &:not(.isDisabled) {
    cursor: pointer;

    &:hover {
      .checkboxType,
      .radiobuttonType {
        &:not(.isChecked) {
          box-shadow: inset 0 0 0 1px $color-blue;
        }
      }
      .switchType {
        &:not(.isChecked) {
          background: transparentize($color-blue, .7);
        }
      }
    }
  }
}

.isDisabled {
  opacity: .6;
  cursor: not-allowed;
}

.label {
  color: $color-gray-900;
  font-size: $font-size-lt;
  line-height: 100%;
}

.labelBefore {
  margin-right: $indent-xsm;
}

.labelAfter {
  margin-left: $indent-xsm;
}

.control {
  position: relative;
}

.checkboxIcon {
  transition: opacity .3s ease;
  opacity: 0;
  color: $color-white;
}

.checkboxType {
  height: 18px;
  width: 18px;
  box-shadow: inset 0 0 0 1px $color-gray-500;
  border-radius: $border-radius-sm;
  transition: box-shadow .3s ease, background .3s ease;
  will-change: box-shadow, background;

  padding: 5px 4px 4px 3px;

  &.isChecked {
    box-shadow: inset 0 0 0 1px $color-blue;
    background: $color-blue;

    .checkboxIcon {
      opacity: 1;
    }
  }
}

.radiobuttonType {
  height: 18px;
  width: 18px;
  box-shadow: inset 0 0 0 1px $color-gray-500;
  border-radius: 100%;
  transition: box-shadow .3s ease;
  will-change: box-shadow;

  &.isChecked {
    box-shadow: inset 0 0 0 5px $color-blue;
  }
}

.switchType {
  height: 18px;
  width: 34px;
  border-radius: 34px;
  background: $color-gray-500;
  transition: background .3s ease, box-shadow .3s ease;
  will-change: background, box-shadow;

  &:before {
    content: '';
    display: block;
    height: 12px;
    width: 12px;
    position: absolute;
    background: $color-white;
    top: 50%;
    transform: translateY(-50%);
    border-radius: 100%;
    left: 4px;

    transition: left .3s ease;
    will-change: left;
  }

  &.isChecked {
    background: $color-blue;

    &:before {
      left: 18px;
    }
  }
}